function [newData ] = relabelData(oldData,origLabels,newLabelList )

% relabelData.m
%
% Take some data that has noncontiguous labels (ie, labels 1 2 4 5) with
% one missing label (ie, 3 in the given case) and relabel the data into
% something contiguous (the new data will be labeled either 1,2,3 or 4.
%
% the terms "label" and "class" are used interchangeably
%
% jeevan@media.mit.edu

% go through the data, one class at a time and relabel it
for i = 1:length(origLabels)
    oldLabel = origLabels(i);
    newLabel = newLabelList(i);
    % if these labels are the same, do nothing and move on
    if (oldLabel ~= newLabel)
        oldData((oldData(:,1) == oldLabel),1) = newLabel;
    end
    

end %i

newData = oldData;