function reducedat(labeleddata,plotdim)
%Can perform PCA to dimension specified by plotdim and then scatter plots
%the results in two or three dimensions (two dimensions if plotdim=2, three 
%dimensions otherwise)
%If you have to make a modification try editing BODY at the bottom
function [maxvecs] = largestEigenvectors(M,vecnum)
[w,v] = eig(M);
[maxVal,maxDim] = max(abs(v));
X=[maxDim;maxVal]';
sorted=sortrows(X,[-2]);
maxvecs = [];
for i=1:vecnum
    maxvecs=cat(2,maxvecs,w(:,sorted(i,1)));
end


end

function [maxvec] = largestEigenvector(M)
[w,v] = eig(M)
[maxVal,maxDim] = max(abs(diag(v)))
maxvec = w(:,maxDim(1))
end

%class scatter matrix
function [mean, scatter] = scatterMatrix(data)
dim = size(data,2);
num = size(data,1);
mean = sum(data)/num;
scatter = zeros(dim,dim);
for(i=1:num)
x = data(i,:);
%do the outer product of x-mean
scatter = scatter + (transpose(x-mean)*(x-mean));
end
end
% Project a data set onto a vector.
function [projected] = projectDataset(data,direction)
projected = zeros(size(data,1),size(direction,2));
for i=1:size(data,1)
projected(i,:) = data(i,:)*direction;
end
end
function [princAxiis] = principleComponent(data,vecnum)
[m,S] = scatterMatrix(data);
princAxiis = largestEigenvectors(S,vecnum);
end
% This is the general form of the discriminant for the two-case
% equiprobable minimum-error-rate one-dimensional normal
% classification scenario. x is the data point in question, m is the
% mean of the distribution and s is the variance of the distribution.
function [num] = g(x,m,s)
num = -(x^2)/(2*s) + (m/s)*x - (m^2)/(2*s) - 0.5*log(s);
end
% Reduce a data set using Fisher Linear Discriminant (FLD).
function [axis] = fldAxis(data0,data1)
% Find the scatter matrix for each class.
[m0,S0] = scatterMatrix(data0);
[m1,S1] = scatterMatrix(data1);
S_within = S0 + S1;
% Find the normalized direction along which to project.
w = inv(S_within)*transpose(m0-m1);
axis = w/norm(w);
end
function [m s] = sampleMeanVariance(v)
m = mean(v);
s = 0;
n = size(v,1);
for i=1:n
s = s + (v(i) - m)^2;
end
s = s/(n - 1.0);
end

    function plotdat3(dn)
        dims=size(dn);
        stop=dims(2);
        start=stop-2;

        camera=[];
        game=[];
        palm=[];
        phone=[];
        remote=[];

        dims=size(dn);
        for i=1:dims(1)
            if  dn(i,1)==1;
                camera=cat(1,camera,dn(i,start:stop));
            elseif dn(i,1)==2;
                game=cat(1,game,dn(i,start:stop));
            elseif  dn(i,1)==3;
                palm=cat(1,palm,dn(i,start:stop));
            elseif   dn(i,1)==4;
                phone=cat(1,phone,dn(i,start:stop));
            elseif   dn(i,1)==5;
                remote=cat(1,remote,dn(i,start:stop));
            end
        end
        
figure
hold on
scatter3(camera(:,1),camera(:,2),camera(:,3),'c*')
scatter3(game(:,1),game(:,2),game(:,3),'g+')
scatter3(palm(:,1),palm(:,2),palm(:,3),'md')
scatter3(phone(:,1),phone(:,2),phone(:,3),'b^')
scatter3(remote(:,1),remote(:,2),remote(:,3),'rs')
legend('camera','game','palm','phone','remote')
view(3)
    
    end

function plotdat2(dn)
    %plot labeled 2d data
        dims=size(dn);
        stop=dims(2);
        start=stop-1;

        camera=[];
        game=[];
        palm=[];
        phone=[];
        remote=[];

        dims=size(dn);
        for i=1:dims(1)
            if  dn(i,1)==1;
                camera=cat(1,camera,dn(i,start:stop));
            elseif dn(i,1)==2;
                game=cat(1,game,dn(i,start:stop));
            elseif  dn(i,1)==3;
                palm=cat(1,palm,dn(i,start:stop));
            elseif   dn(i,1)==4;
                phone=cat(1,phone,dn(i,start:stop));
            elseif   dn(i,1)==5;
                remote=cat(1,remote,dn(i,start:stop));
            end
        end
        
figure
hold on
scatter(camera(:,1),camera(:,2),'c*')
scatter(game(:,1),game(:,2),'g+')
scatter(palm(:,1),palm(:,2),'md')
scatter(phone(:,1),phone(:,2),'b^')
scatter(remote(:,1),remote(:,2),'rs')
legend('camera','game','palm','phone','remote')

    
    end






%*********************************BODY********************
%plotdim=2;%our plots are in 3d
labels=labeleddata(:,1);
data=labeleddata(:,2:end);
axis_pca0 = principleComponent(data,plotdim);
reducedata = projectDataset(data,axis_pca0);

if plotdim==2
plotdat2([labels,reducedata]);
else
plotdat3([labels,reducedata]);
end
%[bestk,bestpp,bestmu,bestcov,dl,countf] = mixtures4(data',5,12,0,1e-4,0)
%plotdat2([labels,data(:,1:2)]);

end